<template>
  <span style="width:100%;height:100%;display:block;overflow:auto;">
    <!-- 流程状态 -->
    <div ref="pendingApproval" class="first-con" v-if="!finished" style="min-height: 86px;">
      <div class="process-status">
        <div class="steps">
          <div class="img">...</div>
        </div>
        <div class="content">
          <div>{{$t('pending')}}</div>
          <div v-for="(items, i) in currentApproversList.nodes" 
            :key="i"> 
            <div class="stateLabel">{{items.stateLabel}}</div>
            <div class="nodesName">
              <span 
                v-for="(item, index) in items.auditors"
                :key="index">
                <span v-if="item.isPosition" style="color:red;">
                  {{item.name}};
                </span>
                <span v-else>
                  {{item.name}};
                </span>
              </span>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- 流程历史 -->
    <!-- <div :class="[!currentApproversList?'dia-con-finsh':'dia-con-progress','dia-con']" style="overflow: auto;"> -->
    <div class="dia-con" :style="{'height':flowInfoHeight,'overflow':'auto'}">
      <div class="list-con">
        <div class="step">
          <div class="p-location">
            <!--结束标志-->
            <div class="process-history" v-if="finished">
              <div class="noAvatar">
                <div class="user-img user-img-end">
                  <i class="fa fa-stop-circle icon-sise"></i>
                </div>
              </div>
              <div class="item-tail-end"></div>
              <div class="content">
                <div class="item">
                  <span class="auditorName">{{currentApproversList?currentApproversList.nodes[0].stateLabel:'完成'}}</span>
                </div>
              </div>
            </div>
            <div class="process-history" v-for="(item, index) in reverseTableData" :key="index">
              <div class="noAvatar">
                <!-- 有头像时显示头像，否则显示名字后两位 -->
                <div class="user-img" v-if="!item.photo">
                  {{item.auditorName.substring(item.auditorName.length-2,item.auditorName.length)}}
                  <span class="node-img">
                    <i v-if="item.flowOperation == 81 " class="fa fa-reply-all" aria-hidden="true" style="color:#f76260;"></i>
                    <i v-else-if="item.flowOperation == 85 " class="fa fa-repeat" aria-hidden="true" style="color:#ffc107;"></i> 
                    <img v-else src="../assets/images/ok.png" />
                  </span>
                </div>
                <div class="user-img" v-else>
                  <img class="avatar" :src="item.photo" />
                  <span class="node-img">
                    <img src="../assets/images/ok.png" />
                  </span>
                </div>
                <div class="line" v-if="reverseTableData.length != index+1"></div>
              </div>
              <div class="content">
                <div class="item">
                  <span class="auditorName">{{item.auditorName}}</span>
                  <span class="startNodeName">（{{item.startNodeName}}）</span>
                  <span class="float-right time">{{item.processtime}}</span>
                </div>
                <div class="attitude" v-if="item.attitude">
                  <span>{{$t('approval_comment')}}：{{item.attitude}}</span>
                </div>
                <div>
                  <img :src="item.signatureImageDate" height="32px">
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </span>
</template>
<script>
import API from "@/api.js";
export default {
  //http://localhost:8081/obpm/contacts/contacts/getAvatar.action?id=GShxHeYbLQQ3d4Vy58b
  props: ["flowinfo","haveActivity"],
  watch: {
    currentApproversList() {
      let isEnd = [];
      let nodes = this.currentApproversList.nodes;
      for(let i=0; i<nodes.length; i++) {
        if(nodes[i].auditors.length == 0 && nodes.coAuditors[i].length == 0) {
          isEnd.push(i);
        }
      }
      if(isEnd.length == nodes.length) {
        this.finished = true;
      }

    }
  },
  data: function() {
    return {
      reverseTableData: [],
      hidePendingApproval:false,
      currentApproversList:'',
      finished:'',
      flowInfoHeight:'100%',
    };
  },
  created() {
    API.getFlowHistorys(
      this.$root.appid, 
      this.flowinfo.docid, 
      {
        onSucess: response => {
          let allData = response.data.data;
          for (let i = 0; i < allData.length; i++) {
            switch (allData[i].flowOperation) {
              case "81":
                  //回退
                  this.hidePendingApproval = true
                  break;
              case "85":
                  this.hidePendingApproval = true
                  break;
              case "88":
                  this.hidePendingApproval = true
                  break;
              case "89":
                  this.hidePendingApproval = true
                  break;
              case "91":
                  this.hidePendingApproval = true
                  break;
              default:
                  this.hidePendingApproval = true
                  break;
            }
            let ymd = allData[i].processtime.split(" ");
            let md = ymd[0].split("-")[1] + "-" + ymd[0].split("-")[2] + " " + ymd[1].split(":")[0] + ":" + ymd[1].split(":")[1];
            response.data.data[i].processtime = md;
          }
          this.reverseTableData = allData;//.reverse();
          for(let i=0; i<this.reverseTableData.length; i++) {
            this.$api.getAvatar(this.reverseTableData[i].auditorId, {
              onSucess: response => {
                this.reverseTableData[i].photo =  response.data.data;
                this.$forceUpdate();
              }
            })
          }
        }
    });
  },
  mounted() {
    this.setCurrentApprovers();
    this.$nextTick(() => {
      let nodesLength = this.currentApproversList?this.currentApproversList.nodes:[];
      if(!this.finished) { //流程未完成
        if(nodesLength && nodesLength.length > 0){
          let totalHeight = 96 + (nodesLength.length-1) * 21;
          this.flowInfoHeight = 'calc(100% - ' + totalHeight  + 'px' + ' )'
        }
        // if(this.haveActivity) { //底下有按钮
        // }else {
        // }
      }
      

    })
  },
  methods: {
    setCurrentApprovers(){
      
      if(this.flowinfo.approvers) {
        if(!this.flowinfo.approvers[0].nodes[0].nodeId) {
          this.finished = true;
        }
        for(let i=0; i<this.flowinfo.approvers.length; i++) {
          if(this.flowinfo.stateId == this.flowinfo.approvers[i].instanceId) {
            
            this.currentApproversList = this.flowinfo.approvers[i];
          }

          // for(let j=0; j<this.flowinfo.approvers[i].nodes.length; j++) {
          //   if(this.flowinfo.approvers[i].nodes[j].auditors.length == 0 && this.flowinfo.approvers[i].nodes[j].coAuditors.length == 0) {
          //     this.finished = true;
          //   }else {
          //     this.finished = false;
          //     //return false;
          //   }
          // }
        }
      }
    }
  }
};
</script>